#ifndef APP_ANGLE_CONTROL_H
#define APP_ANGLE_CONTROL_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "window.h"

#include <windows.h>

/*************************************************

	Rg[̃NX

**************************************************/

APP_BEGIN_NAMESPACE

enum 
{
	ANGLE_CHANGED,
};

class AngleControl : public Window
{
public:
	AngleControl();
	virtual ~AngleControl() throw();

	virtual LRESULT WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);
	double GetAngle() const;
	void SetAngle(double angle);
	void SetAsRotation(bool isAsRotation);
protected:
	void OnDrawItem(DRAWITEMSTRUCT *drawItemStruct) const;
	void DrawArrow(HDC hdc,const RECT &rect,double angle) const;
	void DrawNumber(HDC hdc,const RECT &rect,double angle) const;
	UINT OnGetDlgCode() const;
	void OnLButtonDown(int x,int y);
	void OnMouseMove(int x,int y);
	void OnLButtonUp();
	void Change(int x,int y);
	virtual void OnDestroy();
private:
	//`Ȃ
	AngleControl(const AngleControl &source);
	const AngleControl &operator=(const AngleControl &source);


	double m_angle;	//px
	bool m_isAsRotation;	//]pƂĕ\邩
};

APP_END_NAMESPACE

#endif

