#ifndef APP_APP_FRAME_H
#define APP_APP_FRAME_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "frame.h"

/*************************************************

	AvP[V Ct[EBhE

**************************************************/

APP_BEGIN_NAMESPACE

class Registry;

class AppFrame : public Frame
{
public:
	AppFrame();
	virtual ~AppFrame() throw();

	virtual void Create(HWND parentWindow);

	void AppInit(Registry *registry);
	void AppSave(Registry *registry);
	void AppQuit() throw();

protected:
	void ExchangeSettings(Registry *registry);
	virtual void OnClose();
	virtual void OnCommand(int id,int notifyCode,HWND hwnd);
	virtual void OnUpdateCommand(int id,Command *command);

	void OnViewToolBar();
	void OnUpdateViewToolBar(Command *command);
	void OnViewStatusBar();
	void OnUpdateViewStatusBar(Command *command);
	void ToggleShowWindow(HWND hwnd);
	void OnViewPanel(int id);
	void OnUpdateViewPanel(int id,Command *command);
	void OnShowAbout();
	void OnShowHelp();
	void OnParentNotify(int event,int id,unsigned long value);
private:
	HWND m_toolBar;	//c[o[
	HWND m_statusBar;	//Xe[^Xo[EBhEnh
	
	RECT m_initWindowRect;	//EBhE̍ŏ̈ʒu
	bool m_initMaximize;	//ŏɍő剻ĕ\邩
	bool m_initShowToolBar;	//ŏ̃c[o[̕\
	bool m_initShowStatusBar;	//ŏ̃Xe[^Xo[̕\
};

APP_END_NAMESPACE

#endif
