#include "prefix.h"

#include "appview.h"
#include "appdoc.h"
#include "frame.h"
#include "winmessage.h"
#include "winman.h"
#include "command.h"

#include "main.h"
#include "dc.h"
#include "event.h"
#include "string.h"
#include "core.h"
#include "idtovalue.h"
#include "verify.h"

#include "optionsdialog.h"
#include "options.h"

#include "tool.h"

#include "image.h"
#include "channel.h"

#include "rescommand.h"
#include "resstring.h"

#include <windows.h>
#include <limits.h>

/*************************************************

	AvP[V r[NX

**************************************************/

APP_BEGIN_NAMESPACE

//100%̂Ƃm_m->zoom̐
#define ZOOM_NORMAL 100

//^[~Ă闝R
enum PAUSE
{
	PAUSE_USER,//p҂~{^
	PAUSE_INACTIVEAPP,//AvP[VANeBułȂ߂ɒ~Ă
	PAUSE_LOGIC,	//vO̓sŒ~Ă
	PAUSE_NO_DOCUMENT,	//Ȃ
	PAUSE_SCROLL,	//XN[Ă
	PAUSE_NO_PARTICLE,	//qȂ

	PAUSE_COUNT
};

#define MARGIN_HORIZONTAL	30
#define MARGIN_VERTICAL	40	

class AppViewMember
{
public:
	AppViewMember()
		:zoom(ZOOM_NORMAL)
		,displayingWaitCount(0)
		,isFirstRedrawError(true)
		,lastTurnTime(0)
	{
		margin.cx=MARGIN_HORIZONTAL;
		margin.cy=MARGIN_VERTICAL;
		FOR(int i=0;i<PAUSE_COUNT;++i) {
			pause[i]=false;
		}
		pause[PAUSE_NO_DOCUMENT]=true;
		pause[PAUSE_NO_PARTICLE]=true;
	}

	bool pause[PAUSE_COUNT];	//^[̒~

	Image redraw;	//ĕ`p̃obt@
	SIZE margin;	//]̑傫
	int zoom;	//r[̊g嗦

	int displayingWaitCount;	//O`悵Ẵ^[
	int lastTurnTime;	//O^[n߂

	bool isFirstRedrawError;	//ĕ\ł̃G[\ł܂łPɌ
};

AppView::AppView()
:m_m(new AppViewMember)
{

}

AppView::~AppView() throw()
{
}

//ŏ̏
void AppView::OnInitialUpdate()
{
	View::OnInitialUpdate();

	SIZE size(GetDocument()->GetSize());
	SetScrollSize(size);

	Core *core=GetDocument()->GetCore();
	core->SetTool(GetTool());

	SetWindowTitle();

	Pause(PAUSE_NO_DOCUMENT,false);
}

//EChȆ薼ݒ
void AppView::SetWindowTitle()
{
	String title;
	VERIFY(title.LoadString(IDS_APPTITLE));

	String caption;
	caption.Format(IDS_CAPTION,title.Get(),m_m->zoom);

	GetFrame()->SetWindowText(caption.Get());
}

#define ZOOM(a_size) ((a_size)*m_m->zoom/ZOOM_NORMAL)
#define ZOOM_REV(a_size) ((a_size)*ZOOM_NORMAL/m_m->zoom)

//r[̃hLg̕\̑傫w肵
//XN[ݒ肷
void AppView::SetScrollSize(SIZE docSize)
{
	SIZE scrollSize;
	scrollSize.cx=ZOOM(docSize.cx)+m_m->margin.cx*2;
	scrollSize.cy=ZOOM(docSize.cy)+m_m->margin.cy*2;
	View::SetScrollSize(scrollSize);
}

//EBhEbZ[W
LRESULT AppView::WindowProc(UINT msg,WPARAM wparam,LPARAM lparam)
{
	switch(msg) {
	case WM_PAINT:
		OnPaint();
		break;

	case WM_LBUTTONDOWN:
		OnLButtonDown((short)LOWORD(lparam),(short)HIWORD(lparam),(int)wparam);
		break;

	case WM_LBUTTONDBLCLK:
		OnLButtonDblClk((short)LOWORD(lparam),(short)HIWORD(lparam),(int)wparam);
		break;

	case WM_LBUTTONUP:
		OnLButtonUp((short)LOWORD(lparam),(short)HIWORD(lparam),(int)wparam);
		break;

	case WM_RBUTTONDOWN:
		OnRButtonDown((short)LOWORD(lparam),(short)HIWORD(lparam),(int)wparam);
		break;

	case WM_MOUSEMOVE:
		OnMouseMove((short)LOWORD(lparam),(short)HIWORD(lparam),(int)wparam);
		break;

	case WM_KEYDOWN:
		OnKeyDown((int)wparam,(UINT)lparam);
		break;

	case WM_KEYUP:
		OnKeyUp((int)wparam,(UINT)lparam);
		break;

	case WM_CAPTURECHANGED:
		OnCaptureChanged((HWND)lparam);
		break;

#if 0	////////////////////////////////
	case WM_SETCURSOR:
		if(OnSetCursor((HWND)wparam,LOWORD(lparam),HIWORD(wparam))) {
			break;
		}
		return View::WindowProc(msg,wparam,lparam);
#endif

	case WM_ACTIVATEAPP:
		OnActivateApp((BOOL)wparam);
		break;

	case APP_WM_UPDATE_COMMAND:
		OnUpdateCommand(wparam,reinterpret_cast<Command*>(lparam));
		break;

	case APP_WM_CHANGE_OPTIONS:
		OnChangeOptions();
		break;

	case APP_WM_GET_PIXEL:
		return OnGetPixel(wparam,lparam);

	default:
		return View::WindowProc(msg,wparam,lparam);
	}
	return 0;
}

void AppView::OnCommand(int id,int notifyCode,HWND hwnd)
{
	switch(id) {
	case ID_OPTIONS:
		OnOptions();
		break;

	case ID_EDIT_UNDO:
		OnEditUndo();
		break;

	case ID_EDIT_REDO:
		OnEditRedo();
		break;

	case ID_EDIT_CLEAR:
		OnEditClear();
		break;

	case ID_ACTION_PAUSE:
		OnUserPause();
		break;

	case ID_ACTION_ERASE_ALL:
		OnEraseAll();
		break;

	case ID_VIEW_PER25:
	case ID_VIEW_PER50:
	case ID_VIEW_PER75:
	case ID_VIEW_PER100:
	case ID_VIEW_PER150:
	case ID_VIEW_PER200:
	case ID_VIEW_PER300:
	case ID_VIEW_PER400:
		OnViewZoom(id);
		break;

	case ID_VIEW_ZOOM_OUT:
		OnViewZoomOut();
		break;

	case ID_VIEW_ZOOM_IN:
		OnViewZoomIn();
		break;

	case ID_VIEW_MAT_CHECKER:
	case ID_VIEW_MAT_WHITE:
	case ID_VIEW_MAT_BLACK:
		OnViewMat(id);
		break;

	case ID_TOOL_PAINT:
	case ID_TOOL_ERASE:
	case ID_TOOL_BLUR:
		OnSelectTool(id);
		break;

	default:
		View::OnCommand(id,notifyCode,hwnd);
		break;
	}
}

//GUI̍XV
void AppView::OnUpdateCommand(int id,Command *command)
{
	View::OnUpdateCommand(id,command);

	switch(id) {
	case ID_EDIT_UNDO:
		OnUpdateEditUndo(command);
		break;

	case ID_EDIT_REDO:
		OnUpdateEditRedo(command);
		break;

	case ID_ACTION_PAUSE:
		OnUpdateUserPause(command);
		break;

	case ID_ACTION_ERASE_ALL:
		OnUpdateEraseAll(command);
		break;

	case ID_VIEW_PER25:
	case ID_VIEW_PER50:
	case ID_VIEW_PER75:
	case ID_VIEW_PER100:
	case ID_VIEW_PER150:
	case ID_VIEW_PER200:
	case ID_VIEW_PER300:
	case ID_VIEW_PER400:
		OnUpdateViewZoom(id,command);
		break;

	case ID_VIEW_MAT_CHECKER:
	case ID_VIEW_MAT_WHITE:
	case ID_VIEW_MAT_BLACK:
		OnUpdateViewMat(id,command);
		break;

	case ID_TOOL_PAINT:
	case ID_TOOL_ERASE:
	case ID_TOOL_BLUR:
		OnUpdateSelectTool(id,command);
		break;
	}
}

//NCAgEBhE̍W當̍Wɂ
POINT AppView::GetDocPoint(int x,int y) const
{
	POINT scroll(GetScrollPos());
	POINT point;
	point.x=x+scroll.x;
	point.y=y+scroll.y;

	RECT docRect;
	CalcDocRect(&docRect);
	point.x-=docRect.left;
	point.y-=docRect.top;
	return point;
}

//EBhEbZ[WƂ̍W
POINT AppView::GetMessagePoint() const
{
	DWORD pos=::GetMessagePos();
	POINTS points(MAKEPOINTS(pos));
	POINT point;
	point.x=points.x;
	point.y=points.y;
	ScreenToClient(&point);
	return GetDocPoint(point.x,point.y);
}

//hLg\`vZ
void AppView::CalcDocRect(RECT *rect) const
{
	SIZE imageSize(GetDocument()->GetSize());
	RECT imageRect;
	::SetRect(&imageRect,0,0,imageSize.cx,imageSize.cy);
	ImageToView(rect,imageRect);
}

//////////////////Cxg//////////////////

//\
void AppView::OnPaint()
{
	PaintDC dc(GetHWND());
	OnPrepareDC(dc.Get());

	RECT docRect;
	CalcDocRect(&docRect);
	::InflateRect(&docRect,1,1);

	HBRUSH frameBrush(static_cast<HBRUSH>
		(::GetStockObject(BLACK_BRUSH)));
	VERIFY(::FrameRect(dc.Get(),&docRect,frameBrush));

	Display(dc.Get());
}

//f
#define COLOR_BYTES 3

//\
void AppView::Display(HDC hdc)
{
	RECT docRect;
	CalcDocRect(&docRect);

	RECT clipRect;
	VERIFY(::GetClipBox(hdc,&clipRect)!=ERROR);

	RECT drawViewRect;
	::IntersectRect(&drawViewRect,&docRect,&clipRect);

	SIZE size;
	size.cx=Width(drawViewRect);
	size.cy=Height(drawViewRect);

	if(size.cx<=0 || size.cy<=0) {
		return;
	}

	try {
		m_m->redraw.Resize(size,COLOR_BYTES);
	} catch(std::exception &) {
		//xG[\ô
		if(m_m->zoom>ZOOM_NORMAL) m_m->zoom=ZOOM_NORMAL;
		if(m_m->isFirstRedrawError) {
			m_m->isFirstRedrawError=false;
			throw;
		}
		return;
	}

	RECT drawImageRect;
	ViewToImage(&drawImageRect,drawViewRect);

	POINT imageOrigin;
	imageOrigin.x=drawImageRect.left;
	imageOrigin.y=drawImageRect.top;

	POINT viewOrigin;
	viewOrigin.x=drawViewRect.left;
	viewOrigin.y=drawViewRect.top;

	if(m_m->zoom==ZOOM_NORMAL) {
		Matting(&(m_m->redraw),GetDocument()->GetImage(),imageOrigin,viewOrigin);
	} else {
		SizingAndMatting(&(m_m->redraw),GetDocument()->GetImage()
			,imageOrigin,viewOrigin,m_m->zoom);
	}

	VERIFY(::SetDIBitsToDevice(hdc
		,viewOrigin.x,viewOrigin.y
		,size.cx,size.cy
		,0,0
		,0
		,size.cy
		,m_m->redraw.Get()
		,m_m->redraw.BitmapInfo()
		,DIB_RGB_COLORS));

	m_m->isFirstRedrawError=true;
}

//wiiq͗l̏ꍇ̏ڂ̑傫
#define CHECKER_SIZE 16
//wiiq͗l̏ꍇ̐F
#define CHECKER_DARK	150	
#define CHECKER_LIGHT	180

static inline
void MattingSub(const unsigned char *srcPtr,unsigned char *destPtr
	,int x,int y,int dark,int light)
{
#define MIXCOLOR(a_colorA,a_colorB,a_rate) ((a_colorA*a_rate+a_colorB*(UCHAR_MAX+1-a_rate))>>CHAR_BIT)

	int matColor;
	if((x^y)&CHECKER_SIZE) {
		matColor=dark;
	} else {
		matColor=light;
	}

	int opacity=srcPtr[CHANNEL_OPACITY];
	if(opacity>0) ++opacity; 
	*destPtr=MIXCOLOR(srcPtr[CHANNEL_BLUE],matColor,opacity);
	++destPtr;
	*destPtr=MIXCOLOR(srcPtr[CHANNEL_GREEN],matColor,opacity);
	++destPtr;
	*destPtr=MIXCOLOR(srcPtr[CHANNEL_RED],matColor,opacity);
}

//wi̐F𓾂
static void GetMatColor(int *dark,int *light)
{
	switch(GetOptions()->viewMat) {
	case MAT_WHITE:
		*dark=*light=255;
		break;
	case MAT_BLACK:
		*dark=*light=0;
		break;

	case MAT_CHECKER:
		*dark=CHECKER_DARK;
		*light=CHECKER_LIGHT;
		break;

	default:
		assert(false);
	}
}

//{Ŕwi̍
void AppView::Matting(Image *dest,const Image *src
	,POINT imageOrigin,POINT viewOrigin)
{
	const int width=dest->Width();
	const int height=dest->Height();

	const unsigned char *srcPtr=src->GetPixel(imageOrigin.x,imageOrigin.y);
	int srcRowBytes=src->RowBytes();
	int srcPixelBytes=src->PixelBytes();
	int srcNextRow=srcRowBytes-srcPixelBytes*width;

	assert(dest->PixelBytes()==3);
	unsigned char *destPtr=dest->GetW();
	int destPadBytes=dest->PadBytes();

	int dark,light;
	GetMatColor(&dark,&light);

	FOR(int y=0;y<height;++y) {
		FOR(int x=0;x<width;++x) {
			MattingSub(srcPtr,destPtr,x+viewOrigin.x,y+viewOrigin.y
				,dark,light);
			destPtr+=3;
			srcPtr+=srcPixelBytes;
		}
		memset(destPtr,0,destPadBytes);
		destPtr+=destPadBytes;
		srcPtr+=srcNextRow;
	}
}

//gƔwi̍
void AppView::SizingAndMatting(Image *dest,const Image *src
	,POINT imageOrigin,POINT viewOrigin,int zoom)
{
#define FIX_BIT 16
#define FIXINT(a_fix) (a_fix>>FIX_BIT)

	assert(zoom>0);
	int step=(ZOOM_NORMAL<<FIX_BIT)/zoom;

	int srcy=imageOrigin.y<<FIX_BIT;

	const int width=dest->Width();
	const int height=dest->Height();

	int srcPixelBytes=src->PixelBytes();

	assert(dest->PixelBytes()==3);
	int srcXMax=src->Width()-1;
	int srcYMax=src->Height()-1;

	unsigned char *destPtr=dest->GetW();
	int destPadBytes=dest->PadBytes();

	int dark,light;
	GetMatColor(&dark,&light);

	FOR(int y=0;y<height;++y) {
		int srcx=imageOrigin.x<<FIX_BIT;
		int srcYPos=FIXINT(srcy);
		if(srcYPos>srcYMax) srcYPos=srcYMax;
		const unsigned char *srcRowPtr=src->GetRow(srcYPos);

		FOR(int x=0;x<width;++x) {
			int srcXPos=FIXINT(srcx);
			if(srcXPos>srcXMax) srcXPos=srcXMax;
			const unsigned char *srcPtr=srcRowPtr+srcPixelBytes*srcXPos;

			MattingSub(srcPtr,destPtr,x+viewOrigin.x,y+viewOrigin.y
				,dark,light);
			destPtr+=3;

			srcx+=step;
		}
		memset(destPtr,0,destPadBytes);
		destPtr+=destPadBytes;
		srcy+=step;
	}
}

//{^
void AppView::OnLButtonDown(int x,int y,int)
{
	//bZ[W̍WɃEBhẼXN[̒l
	//Wn

	POINT point(GetDocPoint(x,y));
	CallTool(EVENT_LEFTDOWN,point,0);
}

//{^𗣂
void AppView::OnLButtonUp(int x,int y,int)
{
	POINT point(GetDocPoint(x,y));
	CallTool(EVENT_LEFTUP,point,0);
}

//{^̂Qx
void AppView::OnLButtonDblClk(int x,int y,int)
{
	POINT point(GetDocPoint(x,y));
	CallTool(EVENT_LEFTDOUBLECLICK,point,0);
}

//E{^
void AppView::OnRButtonDown(int x,int y,int)
{
	POINT point(GetDocPoint(x,y));
	CallTool(EVENT_RIGHTDOWN,point,0);
}

//J[\̈ړ
void AppView::OnMouseMove(int x,int y,int)
{
	POINT point(GetDocPoint(x,y));
	CallTool(EVENT_MOUSEMOVE,point,0);
}

//L[
void AppView::OnKeyDown(int key,UINT)
{
	//L[͂łWnȂƂȂ
	POINT point(GetMessagePoint());
	CallTool(EVENT_KEYDOWN,point,key);
}

//L[𗣂
void AppView::OnKeyUp(int key,UINT)
{
	POINT point(GetMessagePoint());
	CallTool(EVENT_KEYUP,point,key);
}

//}EXLv`[؂Ă̂Ƀc[쒆Ȃ璆~
void AppView::OnCaptureChanged(HWND hwnd)
{
	if(GetHWND()==hwnd && IsToolCapturing()) {
		POINT point={0,0};
		CallTool(EVENT_CANCEL,point,0);
	}
}

//c[̃Cxg
void AppView::CallTool(int event,POINT point,int key)
{
	Core *core=GetDocument()->GetCore();
	EVENT_PARAM param;
	param.image=GetDocument()->GetImage();
	param.core=core;
	param.event=event;

	FPOINT imagePoint;
	DocToImage(&imagePoint,point);
	param.point=imagePoint;
	param.key=key;

	ToolEntry(&param);

	if(IsToolCapturing()) {
		if(::GetCapture()!=GetHWND()) {
			SetCapture();
		}
	} else {
		if(::GetCapture()==GetHWND()) {
			::ReleaseCapture();
		}
	}

	if(m_m->pause[PAUSE_NO_PARTICLE] && core->HasParticle()) {
		Pause(PAUSE_NO_PARTICLE,false);
		::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
	}
}

//////////////////////////////////////////////////////

#if 0 //////////////////////////////
//J[\̕\
bool AppView::OnSetCursor(HWND hwnd,int hitTest,int)
{
	if(hwnd==GetHWND() && hitTest==HTCLIENT) {
		if(SetCursor()) {
			return true;
		}
	}
	return false;
}
#endif

//EBhȆ傫ύXꂽ
void AppView::OnSize(UINT type,int width,int height)
{
	View::OnSize(type,width,height);
	InvalidateRect();
}

#if 0	///////////////////////////
//J[\̕ύX
bool AppView::SetCursor()
{

	UINT cursorID=0;
	const _TCHAR * standardCursor=NULL;

	//vύX c[̏Ԃ擾ăJ[\ύX

	HCURSOR cursor(NULL);
	if(cursorID!=0) {
		cursor=::LoadCursor(GetInstance(),MAKEINTRESOURCE(cursorID));
		assert(cursor!=NULL);
	} else if(standardCursor!=NULL) {
		cursor=::LoadCursor(NULL,MAKEINTRESOURCE(standardCursor));
		assert(cursor!=NULL);
	}

	if(cursor!=NULL) {
		VERIFY(::SetCursor(cursor)!=NULL);
		return true;
	}

	return false;
}
#endif

//Xe[^Xo[͕̕\
void AppView::SetStatusText()
{
	//c[̏Ԃ擾
//	int condition=m_m->tool.GetCondition();
	UINT textID=0;	//\[XID

/*	switch(condition) {
	default:
		assert(false);
	}*/

	View::SetStatusText(textID);
}

POINT AppView::ViewMargin() const
{
	RECT clientRect;
	GetClientRect(&clientRect);
	int clientWidth=clientRect.right-clientRect.left;
	int clientHeight=clientRect.bottom-clientRect.top;

	SIZE imageSize(GetDocument()->GetSize());

	POINT margin;
	if(ZOOM(imageSize.cx)+m_m->margin.cx*2>clientWidth) {
		margin.x=m_m->margin.cx+clientRect.left;
	} else {
		margin.x=(clientWidth-ZOOM(imageSize.cx))/2+clientRect.left;
	}

	if(ZOOM(imageSize.cy)+m_m->margin.cy*2>clientHeight) {
		margin.y=m_m->margin.cy+clientRect.top;
	} else {
		margin.y=(clientHeight-ZOOM(imageSize.cy))/2+clientRect.top;
	}

	return margin;
}

//摜̋`\̋`ɕϊ
void AppView::ImageToView(RECT *viewRect,const RECT &imageRect) const
{
	POINT margin(ViewMargin());

	viewRect->left=margin.x+ZOOM(imageRect.left);
	viewRect->top=margin.y+ZOOM(imageRect.top);
	viewRect->right=margin.x+ZOOM(imageRect.right);
	viewRect->bottom=margin.y+ZOOM(imageRect.bottom);
}

//\̋`̍W摜̋`ɕϊ
void AppView::ViewToImage(RECT *imageRect,const RECT &viewRect) const
{
	POINT margin(ViewMargin());

	assert(m_m->zoom!=0);

	imageRect->left=ZOOM_REV(viewRect.left-margin.x);
	imageRect->top=ZOOM_REV(viewRect.top-margin.y);
	imageRect->right=ZOOM_REV(viewRect.right-margin.x);
	imageRect->bottom=ZOOM_REV(viewRect.bottom-margin.y);
}

//\̍W摜̍Wɕϊ
void AppView::DocToImage(FPOINT *imagePoint,POINT docPoint) const
{
	assert(m_m->zoom!=0);

	imagePoint->x=ZOOM_REV(docPoint.x);
	imagePoint->y=ZOOM_REV(docPoint.y);
}

//R}hIDg嗦ɂ
const static IDToValueTable s_zoomTable[]={
	{ID_VIEW_PER25,25},
	{ID_VIEW_PER50,50},
	{ID_VIEW_PER75,75},
	{ID_VIEW_PER100,100},
	{ID_VIEW_PER150,150},
	{ID_VIEW_PER200,200},
	{ID_VIEW_PER300,300},
	{ID_VIEW_PER400,400},

	{0,0}
};

//r[̊g嗦ύX
void AppView::OnViewZoom(int id)
{
	int zoom=IDToValue(s_zoomTable,id);
	SetZoom(zoom);
}

//g嗦ύXăr[\Ȃ
void AppView::SetZoom(int zoom)
{
	m_m->zoom=zoom;

	SIZE docSize(GetDocument()->GetSize());
	SetScrollSize(docSize);
	InvalidateRect();

	SetWindowTitle();
}

void AppView::OnUpdateViewZoom(int id,Command *command)
{
	int zoom=IDToValue(s_zoomTable,id);

	command->SetCheck(m_m->zoom==zoom);
}

//\k
void AppView::OnViewZoomOut()
{
	int zoom=IDToValuePrev(s_zoomTable,m_m->zoom);
	SetZoom(zoom);
}

//\g
void AppView::OnViewZoomIn()
{
	int zoom=IDToValueNext(s_zoomTable,m_m->zoom);
	SetZoom(zoom);
}

//^[
void AppView::OnTurn()
{
	if(!IsWindow() || !IsWindowEnabled() || !IsWindowVisible()) {
		return;
	}

	Core *core=GetDocument()->GetCore();
	Image *image=GetDocument()->GetImage();
	core->Progress(image);

	if(m_m->displayingWaitCount<INT_MAX) ++m_m->displayingWaitCount;

	assert(m_m->displayingWaitCount>=0);
	int displayingInterval=GetOptions()->displayingInterval;
	assert(displayingInterval>=0);
	if(m_m->displayingWaitCount>=displayingInterval) {
		ClientDC dc(GetHWND());
		OnPrepareDC(dc.Get());
		Display(dc.Get());
		m_m->displayingWaitCount=0;

		if(!core->HasParticle()) {
			Pause(PAUSE_NO_PARTICLE,true);
			GetDocument()->Record();
			::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
		}
	}

	POINT point(GetMessagePoint());
	CallTool(EVENT_TURN,point,0);
}

//炩̗Rɂ^[̒~A쓮
void AppView::Pause(int reason,bool paused)
{
	m_m->pause[reason]=paused;
}

//^[~Ă邩
bool AppView::IsPaused() const
{
	bool doPause=false;
	FOR(int i=0;i<PAUSE_COUNT;++i) {
		if(m_m->pause[i]) {
			doPause=true;
		}
	}
	return doPause;
}

//p҂~{^
void AppView::OnUserPause()
{
	Pause(PAUSE_USER,!m_m->pause[PAUSE_USER]);
	::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
}

void AppView::OnUpdateUserPause(Command *command)
{
	command->SetCheck(m_m->pause[PAUSE_USER]);
}

//SĂ̗q
void AppView::OnEraseAll()
{
	Core *core=GetDocument()->GetCore();
	core->Clear();
}

void AppView::OnUpdateEraseAll(Command *command)
{
	Core *core=GetDocument()->GetCore();
	command->SetEnable(core->HasParticle());
}

//r[O
void AppView::OnDestroy()
{
	Pause(PAUSE_LOGIC,true);
	Window::OnDestroy();
}

//ANeBuȃAvP[V̐؂ւ
void AppView::OnActivateApp(BOOL isActivate)
{
	Pause(PAUSE_INACTIVEAPP,isActivate==FALSE);
}

//ݒ_CAOJ
void AppView::OnOptions()
{
	OptionsDialog dialog;
	dialog.DoModal(GetHWND());
}

//ݒύX
void AppView::OnChangeOptions()
{
	Pause(PAUSE_LOGIC,true);

	GetDocument()->OnChangeOptions();
	::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);

	Pause(PAUSE_LOGIC,false);
}

//wi̕\
const static IDToValueTable s_matTable[MAT_COUNT+1]={
	{ID_VIEW_MAT_CHECKER,MAT_CHECKER},
	{ID_VIEW_MAT_WHITE,MAT_WHITE},
	{ID_VIEW_MAT_BLACK,MAT_BLACK},

	{0,0}
};

//wiύX
void AppView::OnViewMat(int id)
{
	OPTIONS options;
	GetOptions(&options);
	options.viewMat=IDToValue(s_matTable,id);
	SetOptions(options);
	InvalidateRect(NULL,false);
}

void AppView::OnUpdateViewMat(int id,Command *command)
{
	int menuMat=IDToValue(s_matTable,id);
	int curMat=GetOptions()->viewMat;
	command->SetCheck(curMat==menuMat);
}

//hLg
void AppView::OnFileClose()
{
	Pause(PAUSE_NO_DOCUMENT,true);
	View::OnFileClose();
}

//ĂȂƂ
bool AppView::OnIdle()
{
	if(IsPaused()) return false;

	//^[i߂
	int turnInterval=GetOptions()->turnInterval;
	int currentTime=::GetTickCount();
	if(currentTime-m_m->lastTurnTime>=turnInterval) {
		OnTurn();
		m_m->lastTurnTime=currentTime;
	}
	return true;
}

//c[̕\
const static IDToValueTable s_toolTable[TOOL_COUNT+1]={
	{ID_TOOL_PAINT,TOOL_PAINT},
	{ID_TOOL_ERASE,TOOL_ERASE},
	{ID_TOOL_BLUR,TOOL_BLUR},

	{0,0}
};

//c[I
void AppView::OnSelectTool(int id)
{
	POINT point={0,0};
	CallTool(EVENT_CANCEL,point,0);

	int toolNumber=IDToValue(s_toolTable,id);
	SetTool(toolNumber);

	Core *core=GetDocument()->GetCore();
	core->SetTool(toolNumber);

	::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
}

void AppView::OnUpdateSelectTool(int id,Command *command)
{
	int toolNumber=IDToValue(s_toolTable,id);
	command->SetCheck(GetTool()==toolNumber);
}

//f̐F𓾂
unsigned long AppView::OnGetPixel(int x,int y)
{
	const Image *image=GetDocument()->GetImage();
	const unsigned char *pixel=image->GetPixel(x,y);

	PA_COLOR color;
	FOR(int c=0;c<PA_COLOR_BYTES;++c) {
		color.channel[c]=pixel[c];
	}
	return color;
}

//ɖ߂
void AppView::OnEditUndo()
{
	GetDocument()->Undo();
	InvalidateRect(NULL,false);
	::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
}

void AppView::OnUpdateEditUndo(Command *command)
{
	AppDoc *doc=GetDocument();
	bool canUndo=doc->CanUndo();
	Core *core=doc->GetCore();
	bool hasParticle=core->HasParticle();
	command->SetEnable(canUndo && !hasParticle);
}

//蒼
void AppView::OnEditRedo()
{
	GetDocument()->Redo();
	InvalidateRect(NULL,false);
	::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
}

void AppView::OnUpdateEditRedo(Command *command)
{
	AppDoc *doc=GetDocument();
	bool canRedo=doc->CanRedo();
	Core *core=doc->GetCore();
	bool hasParticle=core->HasParticle();
	command->SetEnable(canRedo && !hasParticle);
}

//摜Sď
void AppView::OnEditClear()
{
	AppDoc *doc=GetDocument();
	doc->GetImage()->Clear();
	if(!doc->GetCore()->HasParticle()) {
		doc->Record();
		::PostMessage(GetParent(),APP_WM_UPDATE_WINDOW,0,0);
		InvalidateRect(NULL,false);
	}
}

APP_END_NAMESPACE
