#ifndef APP_BUFFER_H
#define APP_BUFFER_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "ucharbuffer.h"

/*************************************************

	obt@[

**************************************************/

APP_BEGIN_NAMESPACE

template <class T> class Buffer : public UCharBuffer
{
public:
	Buffer()
	{
	}
	Buffer(const Buffer<T> &source)
		:UCharBuffer(source)
	{
	}

	virtual ~Buffer() throw()
	{
	}

	const Buffer<T> &operator=(const Buffer<T> &source)
	{
		UCharBuffer::operator=(source);
		return *this;
	}

	//vfύX
	void Alloc(int count)
	{
		UCharBuffer::Alloc(count*sizeof(T));
	}

	//Ƃ̃f[^\c܂ܗvfύX
	void Realloc(int count)
	{
		UCharBuffer::Realloc(count*sizeof(T));
	}

	//݊mۂĂ葽ꍇɗvf𑝂₷
	void Increase(int count)
	{
		UCharBuffer::Increase(count*sizeof(T));
	}

	//擪AhX
	const T *Get() const
	{
		return reinterpret_cast<const T*>(UCharBuffer::Get());
	}

	T *GetW()
	{
		return reinterpret_cast<T*>(UCharBuffer::GetW());
	}

	//indexԖڂ̗vf
	const T &At(int index) const
	{
		return *(Get()+index);
	}

	T &At(int index)
	{
		return *(GetW()+index);
	}

	const T& operator[](int index) const
	{
		return At(index);
	}

	T& operator[](int index)
	{
		return At(index);
	}

	//vf
	int Count() const
	{
		return UCharBuffer::Bytes()/sizeof(T);
	}

	using UCharBuffer::Bytes;
	using UCharBuffer::IsEmpty;
};

APP_END_NAMESPACE

#endif
