#ifndef APP_CATALOG_PANEL_H
#define APP_CATALOG_PANEL_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "panel.h"

#include <memory>
#include <tchar.h>

/*************************************************

	Xv[ꗗpl

**************************************************/

APP_BEGIN_NAMESPACE

struct SPRAYSTYLE;
class String;
class File;
class UpdateControl;

class CatalogPanel : public Panel
{
public:
	CatalogPanel();	
	virtual ~CatalogPanel() throw();
protected:
	virtual void ExchangeSettings(Registry *registry);
	virtual void OnInitDialog();
	virtual void OnDestroy();
	virtual void OnCommand(int id,int notifyCode,HWND hwnd);
	virtual void DataExchange(UpdateControl *updater);

	void GetFileName(String *filename) const;
	void GetPresetFileName(String *filename) const;
	bool Open(const _TCHAR * filename);
	void ReadStyle(File *file,const _TCHAR * filename);
	void Save(const _TCHAR * filename);
	void WriteStyle(File *file,int index);

	void OnAdd();
	void OnRemove();
	void OnReplace();
	void OnOpen();
	void OnSelect();

	int GetSelect();
	int GetCount();
	void GetItemName(int index,String *name);

	int AddItem(const _TCHAR * name,const SPRAYSTYLE &sprayStyle);
	void RemoveItem(int index);
	void RemoveAll();
	SPRAYSTYLE *GetItem(int index);

	LONG SendListMessage(UINT message,WPARAM wparam,LPARAM lparam);
private:
	const std::auto_ptr<class CatalogPanelMember> m_m;
};

APP_END_NAMESPACE

#endif
