#include "prefix.h"

#include "color.h"
#include "tool.h"
#include "channel.h"
#include "registry.h"
#include "string.h"

#include <tchar.h>

/*************************************************

	c[Ƃ̐F

**************************************************/

APP_BEGIN_NAMESPACE

static COLOR_INFO s_toolColor[TOOL_COUNT];

static void ExchangeSettings(Registry *registry);

//AvP[V̍ŏ̏
void AppInit_Color(Registry *registry)
{
	ExchangeSettings(registry);
}

//ݒ̕ۑ
void AppSave_Color(Registry *registry)
{
	ExchangeSettings(registry);
}

//AvP[VI
void AppQuit_Color() throw()
{
}

static void ExchangeSettings(Registry *registry)
{
	const unsigned char defaultColor[COLOR_COUNT][PA_COLOR_BYTES]={
		0xff,0,0,0xff,
		0,0,0,0xff
	};

	FOR(int i=0;i<TOOL_COUNT;++i) {
		String subKey;
		subKey.Format(_T("%s\\Color"),ToolType(i)->name);
		registry->OpenSubKey(subKey.Get());

		FOR(int j=0;j<COLOR_COUNT;++j) {
			FOR(int c=0;c<PA_COLOR_BYTES;++c) {
				if((ToolType(i)->useColor&& c<COLOR_BYTES)
					||(ToolType(i)->useOpacity && c==CHANNEL_OPACITY)) {

					String name;
					name.Format(_T("Color%d_%d"),j,c);
					registry->Exchange(name.Get()
						,&(s_toolColor[i].color[j].channel[c])
						,defaultColor[j][c]);
				}
			}
		}

		registry->Exchange(_T("useFore"),&(s_toolColor[i].isForeSelected),true);
		registry->Exchange(_T("Coloring"),&(s_toolColor[i].coloring),COLORING_SINGLE);
		registry->Exchange(_T("CycleLength"),&(s_toolColor[i].cycleLength),6);
	}
}

//F𓾂
const COLOR_INFO *GetColorInfo(int tool)
{
	assert(CURRENT_TOOL<=tool && tool<TOOL_COUNT);
	if(tool<0) tool=GetTool();

	return &(s_toolColor[tool]);
}

void GetColorInfo(COLOR_INFO *colorInfo,int tool)
{
	assert(CURRENT_TOOL<=tool && tool<TOOL_COUNT);
	if(tool<0) tool=GetTool();

	*colorInfo=s_toolColor[tool];
}

//Fݒ肷
void SetColorInfo(const COLOR_INFO &colorInfo,int tool)
{
	assert(CURRENT_TOOL<=tool && tool<TOOL_COUNT);
	if(tool<0) tool=GetTool();

	s_toolColor[tool]=colorInfo;
	CorrectColorInfo(&(s_toolColor[tool]));
}

//͈͂𒴂lC
void CorrectColorInfo(COLOR_INFO *colorInfo)
{
	if(colorInfo->coloring<0 || COLORING_COUNT <=colorInfo->coloring) {
		colorInfo->coloring=COLORING_SINGLE;
	}
	if(colorInfo->cycleLength<=0) {
		colorInfo->cycleLength=1;
	}
}

APP_END_NAMESPACE
