#ifndef APP_DC_H
#define APP_DC_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "verify.h"

#include <windows.h>
#include <assert.h>

/*************************************************

	foCXReLXg̊Ǘ

**************************************************/

APP_BEGIN_NAMESPACE

class GdiObject;

//{NX
class DC
{
public:
	explicit DC(HDC hdc=NULL);
	virtual ~DC() throw();
	HDC Get();

	void Release() throw();

	void SelectObject(GdiObject *object);
	void DeselectObject(DWORD type) throw();
	void SetROP2(int rop);
	void SetBkMode(int bkMode);
protected:
	void Initialize();

	HDC m_hdc;
private:
	//`ĂȂ
	DC(const DC &source);
	const DC &operator=(const DC &source);

	GdiObject *m_penObject;
	GdiObject *m_brushObject;
	GdiObject *m_bitmapObject;

	HGDIOBJ m_oldPen;
	HGDIOBJ m_oldBrush;
	HGDIOBJ m_oldBitmap;
	int m_oldROP;
	int m_oldBkMode;
};

//WM_PAINTp
class PaintDC : public DC
{
public:
	explicit PaintDC(HWND hwnd);
	virtual ~PaintDC() throw();
private:
	PaintDC();
	PAINTSTRUCT m_paintStruct;
	HWND m_hwnd;
};

//NCAgʗp
class ClientDC : public DC
{
public:
	explicit ClientDC(HWND hwnd);
	virtual ~ClientDC() throw();
private:
	ClientDC();
	ClientDC(const ClientDC &source);
	const ClientDC &operator=(const ClientDC &source);

	HWND m_hwnd;
};

//DrawItemStructp
class DrawItemDC : public DC
{
public:
	explicit DrawItemDC(HDC hdc);
	virtual ~DrawItemDC() throw();
private:
	DrawItemDC();
	DrawItemDC(const DrawItemDC &source);
	const DrawItemDC &operator=(const DrawItemDC &source);
};

APP_END_NAMESPACE

#endif
