#ifndef APP_DELAY_DIFF_H
#define APP_DELAY_DIFF_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "delay.h"

#include <memory>

/*************************************************

	f[^\̒x 

**************************************************/

APP_BEGIN_NAMESPACE

class DelayDiff : public Delay
{
public:
	DelayDiff(std::auto_ptr<Delay> left,std::auto_ptr<Delay> right,bool doesAdd);
	DelayDiff(Delay *left,Delay *right,bool doesAdd);
	virtual ~DelayDiff() throw();

	virtual bool IsEOF() const;

	virtual int PoolBytes() const;
	virtual const unsigned char *Get();
	virtual void Advance(int bytes);

	virtual int Read(void *data,int bytes);

	bool HasDifference() const;
private:
	DelayDiff(const DelayDiff &source);
	const DelayDiff &operator=(const DelayDiff &source);

	const std::auto_ptr<class DelayDiffMember> m_m;
};

APP_END_NAMESPACE

#endif
