#ifndef APP_DIALOG_H
#define APP_DIALOG_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "window.h"

#include <windows.h>
#include <memory>

/*************************************************

	_CAO{NX

**************************************************/

APP_BEGIN_NAMESPACE

class Command;
class UpdateControl;
class GdiObject;
struct IDToValueTable;

class Dialog : public Window
{
public:
	explicit Dialog(int id);
	virtual ~Dialog() throw();

	void Create(HWND parent);
	virtual LRESULT WindowProc(UINT msg,WPARAM wparam,LPARAM lparam);

	int DoModal(HWND parent=NULL);

	void EnableItem(UINT itemID,bool isEnabled);
	virtual bool DestroyWindow();
protected:
	void PreOnInitDialog();
	virtual void OnInitDialog();
	void SetButtonImage(GdiObject *holder,const IDToValueTable *table,int count);
	void PreOnCommand(WPARAM wparam,LPARAM lparam);
	virtual void OnCommand(int id,int notifyCode,HWND hwnd);
	virtual void OnUpdateCommand(UINT id,Command *command);
	virtual void OnControl(int id,int code,LPARAM lparam);
	virtual void OnOK();
	void OnCancel();
	void UpdateData(bool toControl);
	virtual void DataExchange(UpdateControl *updateControl) {};
	bool IsInitialized() const;
	virtual void OnDrawItem(int itemID,DRAWITEMSTRUCT *drawItemStruct);
	virtual void OnDestroy();
	virtual void OnApply();
	virtual bool Apply();
	void OnNotify(int id,NMHDR *nmhdr);
private:
	//`Ȃ
	Dialog();
	Dialog(const Dialog &source);
	const Dialog &operator=(const Dialog &source);

	const std::auto_ptr<class DialogMember> m_m;
};

APP_END_NAMESPACE

#endif

