#ifndef APP_FILE_FileException_H
#define APP_FILE_FileException_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "exception.h"

#include <windows.h>
#include <stdlib.h>
#include <tchar.h>

/*************************************************

	ONX

**************************************************/

APP_BEGIN_NAMESPACE

class FileException : public Exception
{
public:
	FileException() throw();
	FileException(int errorCode,const _TCHAR * filename) throw();
	FileException(int errorCode,DWORD apiErrorCode
		,const _TCHAR * filename) throw();
	FileException(const FileException &source) throw();
	const FileException &operator=(const FileException &source) throw();
	virtual ~FileException() throw();
	virtual const char *what() const throw();
	const _TCHAR * GetFileName() const throw();
protected:
	void CopyFileName(const _TCHAR * filename) throw();
private:
	_TCHAR m_filename[_MAX_PATH];
};

APP_END_NAMESPACE

#endif
