#include "prefix.h"

#include "gdiobject.h"
#include "dc.h"
#include "verify.h"

#include <windows.h>
#include <assert.h>

/*************************************************

	GDIIuWFNg̊Ǘ

**************************************************/

APP_BEGIN_NAMESPACE

GdiObject::GdiObject()
	:m_dc(NULL)
	,m_object(NULL)
{

}

GdiObject::GdiObject(HGDIOBJ object)
	:m_dc(NULL)
	,m_object(NULL)
{
	Attach(object);
}

GdiObject::GdiObject(int number)
	:m_dc(NULL)
	,m_object(NULL)
{
	SetStockObject(number);
}

GdiObject::~GdiObject() throw()
{
	Delete();
}

//GDIIuWFNgL
void GdiObject::Attach(HGDIOBJ object)
{
	Delete();
	assert(object!=NULL);		
	m_object=object;
	m_type=::GetObjectType(object);
	assert(m_type!=0);
}

//XgbNIuWFNgL
void GdiObject::SetStockObject(int number)
{
	Delete();

	m_object=::GetStockObject(number);
	assert(m_object!=NULL);
	m_type=::GetObjectType(m_object);
	assert(m_type!=0);
}

//LĂGDIIuWFNg𓾂
HGDIOBJ GdiObject::Get() const
{
	return m_object;
}

//GDIIuWFNg폜BXgbNIuWFNgȂ؂藣B
void GdiObject::Delete() throw()
{
	if(m_object!=NULL) {
		if(m_dc!=NULL) {
			m_dc->DeselectObject(Type());
			m_dc=NULL;
		}
		VERIFY(::DeleteObject(m_object));
		m_object=NULL;
	}
}

//DCɑIꂽƂDCĂ΂
void GdiObject::Select(DC *dc)
{
	m_dc=dc;		
}

//DC̑I~߂ƂDCĂ΂
void GdiObject::Deselect() throw()
{
	m_dc=NULL;
}

//GDIIuWFNg̎
DWORD GdiObject::Type() const throw()
{
	return m_type;
}

HBRUSH GdiObject::GetBrush() const
{
	assert(Type()==OBJ_BRUSH);
	return static_cast<HBRUSH>(m_object);
}

HPEN GdiObject::GetPen() const
{
	assert(Type()==OBJ_PEN);
	return static_cast<HPEN>(m_object);
}

HBITMAP GdiObject::GetBitmap() const
{
	assert(Type()==OBJ_BITMAP);
	return static_cast<HBITMAP>(m_object);
}

HRGN GdiObject::GetRegion() const
{
	assert(Type()==OBJ_REGION);
	return static_cast<HRGN>(m_object);
}

APP_END_NAMESPACE
