#ifndef APP_PTR_DEQUE_H
#define APP_PTR_DEQUE_H

#include "site.h"

#include <deque>
#include <algorithm>

/*************************************************

	|C^z̃ev[gNX̒`

**************************************************/

APP_BEGIN_NAMESPACE

typedef std::deque<void*> PtrDequeBase;

template <class T>
 class PtrDeque
{
	typedef PtrDequeBase::iterator Iterator;
public:
	PtrDeque();
	~PtrDeque() throw();

	bool IsEmpty() const;

	void Add(T *item);
	void EraseAfter(int index);
	void EraseBefore(int index);
	void Destroy() throw();

	T *At(int index);
	const T* At(int index) const;

	T *RevAt(int rIndex);
	const T* RevAt(int rIndex) const;

	int Count() const;
protected:
	void Erase(Iterator first,Iterator last);

private:
	PtrDequeBase m_base;
};

template <class T>
PtrDeque<T>::PtrDeque()
{
}

template <class T>
PtrDeque<T>::~PtrDeque() throw()
{
	Destroy();
}

template <class T>
bool PtrDeque<T>::IsEmpty() const
{
	return m_base.empty();
}

//ɗvf
template <class T> 
void PtrDeque<T>::Add(T *item)
{
	m_base.push_back(item);
}

template <class T>
void PtrDeque<T>::Erase(Iterator first,Iterator last)
{
	FOR(Iterator i=first;i!=last;++i) {
		T* item=reinterpret_cast<T*>(*i);
		delete item;
	}
	m_base.erase(first,last);
}

//w肵ԍȍ~폜
template <class T>
void PtrDeque<T>::EraseAfter(int index)
{
	Iterator first=m_base.begin()+index;
	Erase(first,m_base.end());
}

//w肵ԍO폜
template <class T>
void PtrDeque<T>::EraseBefore(int index)
{
	Iterator last=m_base.begin()+index;
	Erase(m_base.begin(),last);
}

//SĂ̗vf폜
template <class T>
void PtrDeque<T>::Destroy() throw()
{
	Erase(m_base.begin(),m_base.end());
}

template <class T>
T *PtrDeque<T>::At(int index)
{
	return static_cast<T*>(m_base.at(index));
}

template <class T>
const T*PtrDeque<T>::At(int index) const
{
	return static_cast<const T*>(m_base.at(index));
}

template <class T>
T *PtrDeque<T>::RevAt(int index)
{
	return static_cast<T*>(At(m_base.size()-index-1));
}

template <class T>
const T*PtrDeque<T>::RevAt(int index) const
{
	return static_cast<const T*>(At(m_base.size()-index-1));
}

template <class T>
int PtrDeque<T>::Count() const
{
	return m_base.size();
}

APP_END_NAMESPACE

#endif
