#ifndef APP_REGISTRY_H
#define APP_REGISTRY_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"

#include <windows.h>
#include <memory>
#include <tchar.h>

/*************************************************

	WXg[t@CƏݒ̌

**************************************************/

APP_BEGIN_NAMESPACE

class String;
struct FPOINT;

class Registry
{
public:
	Registry();
	~Registry() throw();

	void OpenAppKey(const _TCHAR *appKey,bool isReading);
	void OpenSubKey(const _TCHAR * subKey); 
	void Exchange(const _TCHAR * name,int *var,int defaultValue);
	void Exchange(const _TCHAR * name,bool *var,bool defaultFlag); 
	void Exchange(const _TCHAR * name,unsigned char *var,unsigned char defaultValue);
	void Exchange(const _TCHAR * name,double *var,double defaultValue);
	void Exchange(const _TCHAR * name,String *var,const _TCHAR * defaultText);
	void Exchange(const _TCHAR * name,RECT *var,const RECT &defaultRect); 
	void Exchange(const _TCHAR * name,FPOINT *var,const FPOINT &defaultPoint);
	bool IsReading() const;

	void DefaultMode();
	void RegistryMode();
private:
	//`ĂȂ
	Registry(const Registry &source);
	const Registry &operator=(const Registry &source);

	HKEY CreateKey(bool isReading,HKEY openKey
		,const _TCHAR * key) const;
	void CloseSubKey();

	const std::auto_ptr<class RegistryMember> m_m;
};

APP_END_NAMESPACE

#endif
