#include "prefix.h"

#include "repulsiondetail.h"
#include "updatecontrol.h"
#include "cellsize.h"
#include "spray.h"
#include "spraystyle.h"
#include "volumecontrol.h"

#include "resdialog.h"

/*************************************************

	͂̏ڍאݒ

**************************************************/

APP_BEGIN_NAMESPACE

class RepulsionDetailMember
{
public:
	VolumeControl effectiveAreaControl;
	double repulsionArea;	//L͈
};

RepulsionDetail::RepulsionDetail()
:LimitDialog(IDD_REPULSION_DETAIL)
,m_m(new RepulsionDetailMember)
{
}

RepulsionDetail::~RepulsionDetail() throw()
{

}

//_CAȌ
void RepulsionDetail::OnInitDialog()
{
	LimitDialog::OnInitDialog();

	m_m->effectiveAreaControl.SubclassDialogItem(IDC_REPULSION_AREA,this);
	m_m->effectiveAreaControl.SetRange(
		SprayStyleType(SPRAYSTYLE_REPULSION_AREA)->lowerLimit
		,SprayStyleType(SPRAYSTYLE_REPULSION_AREA)->upperLimit);
	m_m->effectiveAreaControl.SetShowMode(VOLUME_SHOW_FLOAT_PIXEL);

	const SPRAYSTYLE *sprayStyle=GetSprayStyle();
	m_m->repulsionArea=sprayStyle->repulsionArea;
}

//Rg[ƕϐ̃f[^\̍XV
void RepulsionDetail::DataExchange(UpdateControl *updater)
{
	LimitDialog::DataExchange(updater);

	updater->Volume(IDC_REPULSION_AREA,&m_m->repulsionArea);
}

//{^
bool RepulsionDetail::Apply()
{
	if(!LimitDialog::Apply()) {
		return false;
	}

	SPRAYSTYLE sprayStyle;
	GetSprayStyle(&sprayStyle);
	sprayStyle.repulsionArea=m_m->repulsionArea;
	SetSprayStyle(sprayStyle);
	return true;
}

APP_END_NAMESPACE
