#include "prefix.h"

#include "showerror.h"
#include "messagebox.h"
#include "string.h"

#include "error.h"
#include "exception.h"
#include "fileexception.h"

#include "idtovalue.h"

#include "resstring.h"

#include <new>
#include <tchar.h>

/*************************************************

	G[̕\

**************************************************/

APP_BEGIN_NAMESPACE

struct ErrorMessage {
	int errorCode;
	int id;
};

//G[ԍ當͂̃\[Xɕϊe[u
static const IDToValueTable s_errorMessageID[]={
	{IDS_ERR_OUT_OF_MEMORY,APPERR_OUT_OF_MEMORY},
	{IDS_ERR_INVALID_DOCUMENT_SIZE,APPERR_INVALID_DOCUMENT_SIZE},
	{IDS_ERR_CANT_CREATE_WINDOW,APPERR_CANT_CREATE_WINDOW},
	{IDS_ERR_INVALID_FILE,APPERR_INVALID_FILE},
	{IDS_ERR_CANT_READ_NEW_FILE,APPERR_CANT_READ_NEW_FILE},
	{IDS_ERR_CANT_ADD_LIST,APPERR_CANT_ADD_LIST},
	{IDS_ERR_INVALID_IMAGE_SIZE,APPERR_INVALID_IMAGE_SIZE},
	{IDS_ERR_CANT_OPEN_HELPFILE,APPERR_CANT_OPEN_HELPFILE},

	{0,0}
};

//G[\
void ShowError(HWND parentWindow,const std::exception &e) throw()
{
	try {
		int errorCode=APPERR_UNKNOWN;
		DWORD apiErrorCode=ERROR_SUCCESS;
		const _TCHAR * filename=NULL;
		if(strcmp(e.what(),std::bad_alloc().what())==0) {
			errorCode==APPERR_OUT_OF_MEMORY;
		} else if(strcmp(e.what(),Exception().what())==0) {
			const Exception *appException
				=reinterpret_cast<const Exception*>(&e);
			errorCode=appException->GetErrorCode();
			apiErrorCode=appException->GetAPIErrorCode();
		} else if(strcmp(e.what(),FileException().what())==0) {
			const FileException *fileException
				=reinterpret_cast<const FileException*>(&e);
			errorCode=fileException->GetErrorCode();
			apiErrorCode=fileException->GetAPIErrorCode();
			filename=fileException->GetFileName();
		}

		String message;
		if(errorCode==APPERR_API) {
			message.LoadSystem(apiErrorCode,filename);
		} else {
			int messageID=ValueToID(s_errorMessageID,errorCode);
			if(messageID<=0) {
				messageID=IDS_ERR_UNKNOWN;
			}
			message.Format(messageID,filename);
		}
		AppMessageBox(parentWindow,message.Get());
	} catch(std::exception) {
		//OɗO𓊂Ăǂ悤Ȃ̂ŉȂ
	}
}

//s𒆎~Ȃꍇ̃G[\
void ShowError(HWND parentWindow,int messageID,double value,double value2)
{
	String message;
	message.Format(messageID,value,value2);
	AppMessageBox(parentWindow,message.Get());
}

APP_END_NAMESPACE


