#include "prefix.h"

#include "spraystyle.h"
#include "volumecontrol.h"
#include "pi.h"
#include "colorinfo.h"

#include "resdialog.h"

/*************************************************

	Xv[̐ݒ

**************************************************/

APP_BEGIN_NAMESPACE

//Xv[ݒ̒łʂɂ񂷂鍀ڂ̏
#define SPRAYVOLUME_TYPE_SET(a1,a_idName,a_regName,a_editableLimit	\
	,a_initLimit,a_lowerLimit,a7,a_showMode)	\
	{IDC_##a_idName,_T(a_regName),a_initLimit,a_lowerLimit,a_showMode,a_editableLimit},

const SPRAYVOLUME_TYPE s_sprayVolumeType[SPRAYVOLUME_TYPE_COUNT]=
{
	SPRAYVOLUME_DO_FUNC(SPRAYVOLUME_TYPE_SET)
};

const SPRAYVOLUME_TYPE *SprayVolumeType(int index)
{
	assert(0<=index && index<SPRAYVOLUME_TYPE_COUNT);
	return &(s_sprayVolumeType[index]);
}

//Xv[ݒ̑SĂ̍ڂ̏
#define SPRAYSTYLE_TYPE_SET(a1,a2,a3,a4,a5,a_lowerLimit,a7,a_upperLimit)	\
	{a_lowerLimit,a_upperLimit},

const SPRAYSTYLE_TYPE s_sprayStyleType[SPRAYSTYLE_TYPE_COUNT]=
{
	SPRAYSTYLE_DO_FUNC(SPRAYSTYLE_TYPE_SET)
};

const SPRAYSTYLE_TYPE *SprayStyleType(int index)
{
	assert(0<=index && index<SPRAYSTYLE_TYPE_COUNT);
	return &(s_sprayStyleType[index]);
}

//gOɓn߂ɑO
void PrepareSprayStyleToUse(SPRAYSTYLE *sprayStyle)
{
	sprayStyle->repulsion/=CELL_SIZE;
	sprayStyle->repulsionArea=(CELL_SIZE*CELL_SIZE)
		/(sprayStyle->repulsionArea*sprayStyle->repulsionArea);
	sprayStyle->gravity/=CELL_SIZE;
	sprayStyle->gravityArea=CELL_SIZE/sprayStyle->gravityArea;
	sprayStyle->viscosityArea=CELL_SIZE/sprayStyle->viscosityArea;
	sprayStyle->velocity.x/=CELL_SIZE;
	sprayStyle->velocity.y/=CELL_SIZE;
	sprayStyle->brake=1-sprayStyle->brake;
	sprayStyle->limitedSpeed/=CELL_SIZE;
	sprayStyle->throwing/=CELL_SIZE;
	sprayStyle->spinAngleWiggle*=2*PI/360;
	sprayStyle->splitAngleWiggle*=2*PI/360;
}

//lݒ肷
void InitializeSprayStyle(SPRAYSTYLE *sprayStyle)
{
#define INITIALIZE(a_varName,a2,a3,a_initValue,a5,a6,a7,a8)	\
	sprayStyle->a_varName=a_initValue;

	SPRAYSTYLE_DO_FUNC(INITIALIZE);
}

//}Nʂ߂̃_~[
inline bool operator <(const FPOINT &a,int b)
{
	assert(false);
	return false;
}

inline bool operator >(const FPOINT &a,int b)
{
	assert(false);
	return false;
}

//͈͂𒴂Ăΐlɒ
void CorrectSprayStyle(SPRAYSTYLE *style)
{
#define CORRECT_LIMIT(a_varName,a2,a3,a4,a_useLower,a_lowerLimit	\
	,a_useUpper,a_upperLimit)	\
	if(a_useLower && style->a_varName<a_lowerLimit) {	\
		style->a_varName=a_lowerLimit;	\
	}	\
	if(a_useUpper && style->a_varName>a_upperLimit) {	\
		style->a_varName=a_upperLimit;	\
	}

	SPRAYSTYLE_DO_FUNC(CORRECT_LIMIT);
}

APP_END_NAMESPACE
