#ifndef APP_SPRAY_STYLE_H
#define APP_SPRAY_STYLE_H

#ifdef _MSC_VER
#pragma once
#endif

#include "site.h"
#include "particleinfo.h"
#include "cellsize.h"

#include <tchar.h>

/*************************************************

	Xv[̐ݒ

**************************************************/

APP_BEGIN_NAMESPACE

/*Xv[ݒ̗ʂ̍ڂɊ֐}Ns
FUNC(a_varName,a_idName,a_regName,a_editableLimit
	,a_initLimit,a_lowerLimit,a_detailDialog,a_showMode)

1 ϐ,2 id ,3 WXg̖O
,4 lύX邩,5 ʂ̏̏l,6l̉
,7 ڍ׃_CAÕNX,8 l̕\@)

  */
#define SPRAYVOLUME_DO_FUNC(a_func)	\
	a_func(repulsion	,REPULSION	,"Repulsion",true	\
		,5		,0.0001	,RepulsionDetail,VOLUME_SHOW_FLOAT)	\
	a_func(gravity		,GRAVITY	,"Gravity"	,true	\
		,5		,0.0001	,GravityDetail,VOLUME_SHOW_FLOAT)	\
	a_func(brake		,BRAKE		,"Brake"	,false	\
		,1		,0		,LimitDialog,VOLUME_SHOW_PERCENT)	\
	a_func(viscosity	,VISCOSITY	,"Viscosity",false	\
		,1		,0		,ViscosityDetail,VOLUME_SHOW_PERCENT)	\
	a_func(velocity		,VELOCITY	,"Velocity"	,true	\
		,5		,0.0001	,VelocityDetail,VOLUME_SHOW_FLOAT)	\
	a_func(limitedSpeed,LIMITED_SPEED,"LimitedSpeed",true	\
		,10		,0.0001	,LimitDialog,VOLUME_SHOW_FLOAT)	\
	a_func(count		,COUNT		,"Count"	,true	\
		,50		,1		,LimitDialog,VOLUME_SHOW_OWNER)	\
	a_func(size		,SPRAY_SIZE		,"Size"		,true	\
		,64		,1		,LimitDialog,VOLUME_SHOW_PIXEL)	\
	a_func(life		,LIFE			,"Life"		,true	\
		,200	,1		,LimitDialog,VOLUME_SHOW_INTEGER)	\
	a_func(throwing	,THROWING		,"Throwing"	,true	\
		,1		,0.0001	,LimitDialog,VOLUME_SHOW_FLOAT)


//ڂɂ̔ԍ
#define SPRAYVOLUME_NUMBERING(a1,a_idName,a3,a4,a5,a6,a7,a8)	\
	SPRAYVOLUME_##a_idName,

enum	//ʂ̍ڂ̔ԍ
{
	SPRAYVOLUME_DO_FUNC(SPRAYVOLUME_NUMBERING)

	SPRAYVOLUME_TYPE_COUNT
};

/*Xv[ݒ̑SĂ̍ڂɊ֐}Ns
FUNC(a_varName,a_idName,a_regName
	,a_initValue
	,a_useLower,a_lowerLimit
	,a_useUpper,a_upperLimit)

1 ϐ,2 id ,3 WXg̖O
 ,4 l ,5 l邩 ,6 l
 ,7@l邩 ,8 l

  */
#define SPRAYSTYLE_DO_FUNC(a_func)	\
	a_func(repulsion	,REPULSION	,"Repulsion"	,2.5	\
		,true	,0	,false	,0)	\
	a_func(repulsionArea,REPULSION_AREA,"RepulsionArea",6.4	\
		,true	,0.0001	,true	,CELL_SIZE)	\
	a_func(gravity		,GRAVITY	,"Gravity"		,2		\
		,true	,0	,false	,0)	\
	a_func(gravityArea	,GRAVITY_AREA,"gravityArea"	,CELL_SIZE		\
		,true	,0.0001,true	,CELL_SIZE)	\
	a_func(brake		,BRAKE		,"Brake"		,0.05	\
		,true	,0	,true	,1)	\
	a_func(viscosity	,VISCOSITY	,"Viscosity"	,0.65	\
		,true	,0	,true	,1)	\
	a_func(viscosityArea,VISCOSITY_AREA,"ViscosityArea",7	\
		,true	,0.0001	,true	,CELL_SIZE)	\
	a_func(life			,LIFE		,"Life"			,20.0	\
		,true	,0	,false	,0)	\
	a_func(limitedSpeed	,LIMITED_SPEED,"LimitedSpeed",1		\
		,true	,0	,false	,0)	\
	a_func(useLimitedSpeed,USE_LIMITED_SPEED,"UseLimitedSpeed",false	\
		,false	,false,false,true)	\
	a_func(velocity		,VELOCITY	,"Velocity"		,OriginPoint()	\
		,false	,0		,false	,0)	\
	a_func(velocityWiggle,VELOCITY_WIGGLE,"VelocityWiggle",0	\
		,true	,0		,true	,1)	\
	a_func(velocityWidth,VELOCITY_WIDTH,"VelocityWidth",1	\
		,true	,0		,true	,360)	\
	a_func(velocityRotationSpeed,VELOCITY_ROTATION_SPEED,"VelocityRotationSpeed",10	\
		,true	,0		,true	,360)	\
	a_func(velocityMode,VELOCITY_MODE,"VelocityMode",VELOCITYMODE_COUNT-1	\
		,true	,0		,true	,VELOCITYMODE_COUNT)	\
	a_func(count		,COUNT		,"Count"		,20		\
		,true	,0		,false	,0)	\
	a_func(size			,SPRAY_SIZE	,"Size"			,10		\
		,true	,0		,false	,0)	\
	a_func(throwing		,THROWING	,"Throwing"		,0.01	\
		,true	,0		,false	,0)	\
	a_func(useSpin		,SPIN_USE	,"UseSpin"	,false	\
		,false	,false	,false	,true)	\
	a_func(spinStep		,SPIN_STEP	,"SpinStep"	,10	\
		,true	,1		,false	,0)	\
	a_func(spinAngle,SPIN_ANGLE,"SpinAngle",0.2	\
		,false	,0		,false	,0)	\
	a_func(spinAngleWiggle,SPIN_ANGLE_WIGGLE,"SpinAngleWiggle",0	\
		,true	,0		,true	,360)	\
	a_func(useSplit		,SPLIT_USE	,"UseSplit"	,false	\
		,false	,false	,false	,true)	\
	a_func(splitMode	,SPLIT_MODE	,"SplitMode"	,0	\
		,true	,0		,true	,SPLITMODE_COUNT-1)	\
	a_func(splitStep1	,SPLIT_STEP1	,"SplitStep1"	,10	\
		,true	,1		,false	,0)	\
	a_func(splitStep2	,SPLIT_STEP2	,"SplitStep2"	,10	\
		,true	,1		,false	,0)	\
	a_func(splitAngle1,SPLIT_ANGLE1,"SplitAngle1",1	\
		,false	,0		,false	,0)	\
	a_func(splitAngle2,SPLIT_ANGLE2,"SplitAngle2",-1	\
		,false	,0		,false	,0)	\
	a_func(splitAngleWiggle,SPLIT_ANGLE_WIGGLE,"SplitAngleWiggle",0	\
		,true	,0		,true	,360)	\
	a_func(splitLag		,SPLIT_LAG	,"SplitLag"	,0	\
		,true	,0		,false	,0)	\
	a_func(splitGenerationsMax,SPLIT_GENERATIONS,"SplitGenerations",3	\
		,true	,1		,false	,0)	\
	a_func(splitRate,SPLIT_RATE,"SplitRate",0	\
		,true	,0.0001	,true	,1)


//ڂɔԍ
#define SPRAYSTYLE_NUMBERING(a1,a_idName,a3,a4,a5,a6,a7,a8)	\
	SPRAYSTYLE_##a_idName,

//SĂ̐ݒ荀ڂ̔ԍ
enum
{
	SPRAYSTYLE_DO_FUNC(SPRAYSTYLE_NUMBERING)

	SPRAYSTYLE_TYPE_COUNT
};

//̌肷@
enum
{
	VELOCITY_LEFT_SPIN,
	VELOCITY_RIGHT_SPIN,
	VELOCITY_WIPER,
	VELOCITY_RANDOM,

	VELOCITYMODE_COUNT
};

//Xv[̏
struct SPRAYSTYLE : public PARTICLE_INFO
{
	FPOINT velocity;	//
	double velocityWiggle;	//̗h炬
	double velocityWidth;	//ˊpx̍L
	double velocityRotationSpeed;	//ˊpx̉]x
	double throwing;		//J[\̓ɍ킹ėqɐ
	int velocityMode;	//ˊpx̌@
	int count;			//xɒu
	int size;			//΂T͈
	int splitGenerationsMax;	//̍ő̐㐔
};

//ʂ̍ڂ̏
struct SPRAYVOLUME_TYPE
{
	int controlID;	//ʃRg[ID
	const _TCHAR * name;	//WXg̖O
	double initLimit;	//̏l
	double lowerLimit;	//l
	int showMode;	//l̕\@
	bool editableLimit;	//ύXł邩
};

const SPRAYVOLUME_TYPE *SprayVolumeType(int index);

//SĂ̍ڂ̏
struct SPRAYSTYLE_TYPE
{
	int lowerLimit;	//l
	int upperLimit;	//l
};

const SPRAYSTYLE_TYPE *SprayStyleType(int index);

void PrepareSprayStyleToUse(SPRAYSTYLE *sprayStyle);
void InitializeSprayStyle(SPRAYSTYLE *sprayStyle);
void CorrectSprayStyle(SPRAYSTYLE *sprayStyle);

APP_END_NAMESPACE

#endif

