#include "prefix.h"

#include "tooltip.h"
#include "main.h"
#include "exception.h"
#include "error.h"
#include "string.h"

#include <windows.h>

/*************************************************

	c[`bv

**************************************************/

APP_BEGIN_NAMESPACE

ToolTip::ToolTip()
{
}

ToolTip::~ToolTip() throw()
{
	DestroyWindow();
}

//Rg[̍쐬
void ToolTip::Create(HWND parentWindow) 
{
	HWND hwnd=::CreateWindow(TOOLTIPS_CLASS,NULL
		,TTS_ALWAYSTIP|WS_EX_TOOLWINDOW|WS_POPUP 
		,CW_USEDEFAULT,CW_USEDEFAULT
		,CW_USEDEFAULT,CW_USEDEFAULT
		,parentWindow
		,NULL
		,GetInstance()
		,NULL);

	if(hwnd==NULL) {
		throw Exception(APPERR_CANT_CREATE_WINDOW);
	}
	Attach(hwnd);
}

void ToolTip::AddItems(HWND dialog)
{
	HWND child=::GetWindow(dialog,GW_CHILD);
	while(child!=NULL) {
		TOOLINFO toolInfo;
		memset(&toolInfo,0,sizeof(toolInfo));
		toolInfo.cbSize=sizeof(toolInfo);
		toolInfo.uFlags=TTF_IDISHWND|TTF_SUBCLASS;
		toolInfo.hwnd=dialog;
		toolInfo.uId=(UINT)child;
		toolInfo.lpszText=LPSTR_TEXTCALLBACK;
		SendMessage(TTM_ADDTOOL,0,(LPARAM)(&toolInfo));
		
		child=::GetWindow(child,GW_HWNDNEXT);
	}
}

//c[`bṽeLXg̗v
void SetToolTipText(TOOLTIPTEXT *toolTipText)
{
	int id=toolTipText->hdr.idFrom;
	if(toolTipText->uFlags & TTF_IDISHWND) {
		id=::GetDlgCtrlID((HWND)id);
	}
	if(id!=0) {
		String description;
		if(description.LoadString(id)) {
			String tips;
			const _TCHAR * text=description.Get();
			if(tips.SingleLine(description,1)) {
				text=tips.Get();
			}
//			memset(toolTipText->szText,0,sizeof(toolTipText->szText));
			_tcsncpy(toolTipText->szText,text,sizeof(toolTipText->szText)/sizeof(_TCHAR)-1);
		}
	}
}


APP_END_NAMESPACE
