#include "prefix.h"

#include "viscositydetail.h"
#include "updatecontrol.h"
#include "cellsize.h"
#include "spray.h"
#include "spraystyle.h"
#include "volumecontrol.h"

#include "resdialog.h"

/*************************************************

	S̏ڍאݒ

**************************************************/

APP_BEGIN_NAMESPACE

class ViscosityDetailMember
{
public:
	VolumeControl effectiveAreaControl;
	double viscosityArea;	//L͈
};

ViscosityDetail::ViscosityDetail()
:LimitDialog(IDD_VISCOSITY_DETAIL)
,m_m(new ViscosityDetailMember)
{
}

ViscosityDetail::~ViscosityDetail() throw()
{
}

//_CAȌ
void ViscosityDetail::OnInitDialog()
{
	LimitDialog::OnInitDialog();

	m_m->effectiveAreaControl.SubclassDialogItem(IDC_VISCOSITY_AREA,this);
	m_m->effectiveAreaControl.SetRange(
		SprayStyleType(SPRAYSTYLE_VISCOSITY_AREA)->lowerLimit
		,SprayStyleType(SPRAYSTYLE_VISCOSITY_AREA)->upperLimit);
	m_m->effectiveAreaControl.SetShowMode(VOLUME_SHOW_FLOAT_PIXEL);

	const SPRAYSTYLE *sprayStyle=GetSprayStyle();
	m_m->viscosityArea=sprayStyle->viscosityArea;
}

//Rg[ƕϐ̃f[^\̍XV
void ViscosityDetail::DataExchange(UpdateControl *updater)
{
	updater->Volume(IDC_VISCOSITY_AREA,&m_m->viscosityArea);
}

//{^
bool ViscosityDetail::Apply()
{
	SPRAYSTYLE sprayStyle;
	GetSprayStyle(&sprayStyle);
	sprayStyle.viscosityArea=m_m->viscosityArea;
	SetSprayStyle(sprayStyle);
	return true;
}

APP_END_NAMESPACE


